require "defines"



local pocketBotsInit = false
local maxhealth = {}
--local alreadyPartOfNetwork = false
local notFirstTime = false

game.onevent(defines.events.ontick, function(event)
	if pocketBotsInit == nil or not pocketBotsInit then
		--game.player.clearconsole()
		
		debugLog("SETUP Start!!!!!!!!!!!!")
		
		pocketBotsInit = true
		
		init()
		maxhealth = getMaxHealth()

		--setupInventories(glob.entityGroup)
		--glob.inventoryStore = createInventoryStore(glob.entityGroup)
		debugLog("SETUP End!!!!!!!!!!!!")
		
		
	end
	
	if glob.entitiesToDestroy ~= nil then
		for i,entitiy in ipairs(glob.entitiesToDestroy) do
			entity.destroy()
		end
		entitiesToDestroy = nil
	end
	
	local forceRefresh = false
	
	if event.tick %120 == 7 then
		forceRefresh = true
	end
		
	if event.tick %15 == 7 then -- This must match the fresh above
		local armorInventory = game.player.getinventory(defines.inventory.playerarmor)
		local currentPosition = game.player.position
		if(armorInventory ~= nil and armorInventory.getitemcount("pocket-bots-armor") > 0) and outsideRoboportRange(currentPosition) then
			--alreadyPartOfNetwork = false
			--debugLog("wearing the armor and outside roboport")
			
			if (glob.entityGroup == nil or glob.entityGroup["position"] == nil)then
				glob.entityGroup = createEntityGroup(currentPosition)
				glob.entityGroup["position"] = currentPosition
				glob.inventoryStore = setupInventories(glob.entityGroup, glob.inventoryStore)
				syncEntityGroup(glob.entityGroup)
				--glob.inventoryStore = --createInventoryStore(glob.entityGroup)
			else
				syncInventorys(glob.entityGroup, glob.inventoryStore)
				glob.inventoryStore = createInventoryStore(glob.entityGroup)
				
				
				if (glob.entityGroup["position"].x ~= currentPosition.x or glob.entityGroup["position"].y ~= currentPosition.y)  or forceRefresh then
					
					glob.entityGroup = updateEntityGroupPosition(glob.entityGroup, currentPosition)
					glob.inventoryStore = setupInventories(glob.entityGroup, glob.inventoryStore)
				else 
					glob.inventoryStore = createInventoryStore(glob.entityGroup)
				end
				syncEntityGroup(glob.entityGroup)
				

				
				
			end
		elseif glob.entityGroup ~= nil then
			--alreadyPartOfNetwork = true
			syncInventorys(glob.entityGroup, glob.inventoryStore)
			glob.inventoryStore = createInventoryStore(glob.entityGroup)
			destroyEntityGroup(glob.entityGroup)
			glob.entityGroup = nil
		else
			--alreadyPartOfNetwork = true
		end
	end
end)

-- game.onevent(defines.events.onbuiltentity, function(event)
	-- debugLog(event.createdentity.name)
-- end)


game.onsave(function()
	debugLog("*******************ONSAVE")
	notFirstTime = true
	--pocketBotsInit = false
	if glob.entityGroup ~= nil then
		
		syncInventorys(glob.entityGroup, glob.inventoryStore)
		glob.inventoryStore = createInventoryStore(glob.entityGroup)
		destroyEntityGroup(glob.entityGroup)
		glob.entityGroup = nil
	end
end)



function init()
	if glob.entityGroup ~= nil then
		--alreadyPartOfNetwork = not outsideRoboportRange(game.player.position)
		if glob.entityGroup.position ~= nil then
			local entityGroup = findEntityGroup(glob.entityGroup.position)
			if entityGroup ~= nil and entityGroup["position"] ~= nil then
				glob.entityGroup = entityGroup
			end
		end
	end
	
end

game.onload(function()
	if not notFirstTime then
		pocketBotsInit = false
		debugLog("*******************ONLOAD")
	end
end)

function outsideRoboportRange(position)
	--local  -- 26, 1 more than roboport logistics range and then some
	local robot = false
	local pocketRoboport = false
	
	--debugLog("Slow Check")
	
	--Find Roboports
	local entities = game.findentitiesfiltered{area = {{position.x - 26, position.y - 26}, {position.x + 26, position.y + 26}}, type = "roboport"}
	for i, entity in ipairs(entities) do
		if entity ~= nil and entity.valid then
			debugLog("Found Robotport")
			if entity.name ~= "roboport-pocket" then
				return false
			else
				debugLog("Pocket roboport")
				pocketRoboport = true
			end
		end
	end
	
	--Find Everything Else
	entities = game.findentities{{position.x - 12, position.y-12},{position.x+12, position.y+12}}

	local forceCount = 0
	entities = game.findentitiesfiltered{area = {{position.x - 12, position.y - 12}, {position.x + 12, position.y + 12}}, force = "player"}
	local allCount = 0
	for i, entity in ipairs(entities) do
		if i > 1000 then
			debugLog("BREAK **************")
			return pocketRoboport
			--break
		end
		allCount = i
		if entity ~= nil and entity.valid then
			if entity.force.name == "player" then
				forceCount = forceCount + 1
				if entity.type == "logistic-robot" then
					return false
				elseif entity.type == "construction-robot" then
					if pocketRoboport then
						return true
					end
				end
				
				if entity.health ~= nil  and entity.health < maxhealth[entity.name] then
					debugLog(maxhealth[entity.name] .. ": " .. entity.health)
					if entity.type ~= "combat-robot" then
						return true
					end
				end
				
				if entity.name == "ghost" then
					return true
				end
			end
		
			if entity.tobedeconstructed(game.player.force) then
				return true
			end
			
		end
	end
	--debugLog("forceCount" .. forceCount .. " / " .. allCount)
	return false
end

function quickOutsideRoboportRange(position) -- oh well
	if position ~= nil then
		
		local entities = game.findentitiesfiltered{area = {{position.x, position.y}, {position.x, position.y}}, name = "roboport-pocket"}
		if entities ~= nil and entities[1] ~= nil and entities[1].valid then
			return true
		end
		
		game.createentity{name="smart-inserter-trans", position=position, force=game.player.force}
		entities = game.findentitiesfiltered{area = {{position.x, position.y}, {position.x,position.y}}, name = "smart-inserter-trans"}
		local inserter
		if entities ~= nil then
			inserter = entities[1]
		end
		
		if inserter ~= nil and inserter.valid then
			if pcall(function () inserter.setcircuitcondition(defines.circuitconnector.logistic, {name = "raw-wood", count = 600, operator = ">"}) end) then
				--debugLog(serpent.block(inserter.getcircuitcondition(defines.circuitconnector.logistic)))
				inserter.destroy()
				return false
			else
				--debugLog("Not part of network")
				inserter.destroy()
			end
		end
	end
	return true
end

function getMaxHealth() 
	local returnValue = {}
	local i = 0
	for name, value in pairs(game.entityprototypes) do
		if value.maxhealth ~= nil and value.maxhealth ~= 0 then
			i = i + 1
			--debugLog(value.maxhealth)
			returnValue[name] = value.maxhealth
		end
	end
	debugLog("Max Health: " .. i)
	return returnValue
end

function syncEntityGroup(entityGroup)
	--debugLog("syncEntityGroup")
	local entityNames = getGroupEntityNames()
	for i, entityName in ipairs(entityNames) do 
		if entityGroup[entityName] ~= nil and entityGroup[entityName].valid then
			if entityGroup[entityName].type == "roboport" or entityGroup[entityName].type == "inserter" then
				entityGroup[entityName].energy = 100000000
			elseif entityGroup[entityName].type == "accumulator" then
				entityGroup[entityName].energy = 1
			end
		end
	end
end

function findEntityGroup(position)
	local entityGroup = {}
	
	local entityNames = getGroupEntityNames()
	local foundEntites = game.findentities{{position.x-1, position.y-1}, {position.x+1, position.y+1}}
	for i, entity in ipairs(foundEntites) do
		if entity ~= nil and entity.valid then
			if matchStringInTable(entity.name, entityNames) then
				--debugLog("found entity: " .. entity.name)
				if entityGroup[entity.name] ~= nil then
					entity.destroy()
				else
					entityGroup[entity.name] = entity
					--entity.orderdeconstruction(game.player.force)
					--if entity.name == "pocket-provider" then
						--entity.teleport({x=entity.position.x, y = entity.position.y + 0})
					--end
					entityGroup["position"] = position
					
				end
			end
		end
	end
	
	return entityGroup
end

function createEntityGroup(position)
	--debugLog("createEntityGroup")
	local entityNames = getGroupEntityNames()
	
	for i, entityName in ipairs(entityNames) do
		game.createentity{name=entityName, position=position, force=game.player.force}
	end
	
	return findEntityGroup(position)
end

function getGroupEntityNames()
	return {"roboport-pocket", "electric-pole-pocket", "pocket-provider", "accumulator-pocket"}
end

function recreateEntity(entity, position)
	if entity ~= nil and entity.valid then
		local entityName = entity.name
		entity.destroy()
		game.createentity{name=entityName, position=position, force=game.player.force}
		local foundEntities = game.findentitiesfiltered{area = {{position.x, position.y}, {position.x, position.y}}, name=entityName}
		if foundEntities ~= nil and foundEntities[1] ~= nil then
			return foundEntities[1]
		end
	end
	--debugLog("No entity found after recreate")
	return nil
end

function updateEntityGroupPosition(entityGroup, position)
	--debugLog("updateEntityGroup")
	
	--if entityGroup["position"].x ~= position.x or entityGroup["position"].y ~= position.y then
		local entityNames = getGroupEntityNames()
		
		local newEntityGroup = createEntityGroup(position)
		
		for i, entityName in ipairs(entityNames) do
			if entityGroup[entityName] ~= nil and entityGroup[entityName].valid then
					entityGroup[entityName].destroy()
			else
				--debugLog("WHAT!!!!!!!!!!" .. entityName)
				--destroyNextTick(entityGroup[entityName])
			end
		end
		
		newEntityGroup["position"] = position
		return newEntityGroup
end



function destroyNextTick(entity)
	if glob.entitiesToDestroy == nil then
		glob.entitiesToDestroy = {}
	end
	table.add(glob.entitiesToDestroy, entiry)
end

function destroyEntityGroup(entityGroup)
	--debugLog("destroyEntityGroup")
	local entityNames = getGroupEntityNames()
	
	for i, entityName in ipairs(entityNames) do
		if entityGroup[entityName] ~= nil and entityGroup[entityName].valid then
			entityGroup[entityName].destroy()
		end
	end
end


function createInventoryStore(entityGroup)
	local inventoryStore = {}
	inventoryStore["player"] = getPlayerInventoryContents()
	
	if entityGroup["roboport-pocket"] ~= nil and entityGroup["roboport-pocket"].valid then
		--debugLog("Found roboport-pocket")
		local roboInventoryA = entityGroup["roboport-pocket"].getinventory(1)
		local roboInventoryB = entityGroup["roboport-pocket"].getinventory(2)
		inventoryStore["roboport-pocket"] = combineContents(roboInventoryA.getcontents(), roboInventoryB.getcontents())
	end
	if entityGroup["pocket-provider"] ~= nil and entityGroup["pocket-provider"].valid then
		--debugLog("Found pocket-provider")
		local providerInventory = entityGroup["pocket-provider"].getinventory(1)
		inventoryStore["pocket-provider"] = providerInventory.getcontents()
	end
	
	return inventoryStore
end

function getPlayerInventoryContents()
	local playerMain =  game.player.getinventory(defines.inventory.playermain)
	return playerMain.getcontents()
	--local playerQuick =  game.player.getinventory(defines.inventory.playerquickbar)
	--return combineContents(playerMain.getcontents(), playerQuick.getcontents())
end

function combineContents(contentsA, contentsB)
	for name, count in pairs(contentsB) do
		if contentsA[name] == nil or contentsA[name] == 0 then
			contentsA[name] = count
		else
			contentsA[name] = contentsA[name] + count
		end
	end
	return contentsA
end

function setupInventories(entityGroup, previousStore)
	syncInventorys(entityGroup, {})
	return createInventoryStore(entityGroup)
end

-- function setupInventories(entityGroup, previousStore)
	-- --debugLog("Setup inventories")
	-- --local playerInventoryGroup = addRobotsToInventories(entityGroup, roboportInventory))
	-- local tempStore = {}

	-- -- for storeName, itemList in pairs(previousStore ) do
		
	-- -- end
	
	-- syncInventorys(entityGroup, {})
	-- local newInventoryStore = createInventoryStore(entityGroup)
	
	-- if previousStore ~= nil and previousStore["roboport-pocket"] ~= nil and newInventoryStore["player"] ~= nil then
		-- if previousStore["roboport-pocket"]["repair-pack"] ~= nil and newInventoryStore["player"]["repair-pack"] ~= nil then
			-- --debugLog("RepairPack" .. previousStore["roboport-pocket"]["repair-pack"] .. " " ..  newInventoryStore["player"]["repair-pack"])
			-- applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(2), "repair-pack", previousStore["roboport-pocket"]["repair-pack"] - newInventoryStore["player"]["repair-pack"] )
			
			-- --applyChangeToInventory(game.player.getinventory(defines.inventory.playermain), "repair-pack", newInventoryStore["player"]["repair-pack"] - previousStore["roboport-pocket"]["repair-pack"])
		-- end
		-- if previousStore["roboport-pocket"]["repair-pack"] ~= nil and newInventoryStore["player"]["repair-pack"] == nil then
			-- --debugLog("RepairPack" .. previousStore["roboport-pocket"]["repair-pack"])
			-- applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(2), "repair-pack", previousStore["roboport-pocket"]["repair-pack"] )
			-- applyChangeToInventory(game.player.getinventory(defines.inventory.playermain), "repair-pack", previousStore["roboport-pocket"]["repair-pack"])
		-- end
		-- if previousStore["roboport-pocket"]["construction-robot"] ~= nil and newInventoryStore["player"]["construction-robot"] ~= nil then
			-- debugLog("construction-robot: robo: " .. previousStore["roboport-pocket"]["construction-robot"] .. " player: " .. newInventoryStore["player"]["construction-robot"])
			-- local change = previousStore["roboport-pocket"]["construction-robot"] - newInventoryStore["player"]["construction-robot"]
			-- if change > 0 then
				-- applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(1), "construction-robot", change)
			-- else
				-- applyChangeToInventory(game.player.getinventory(defines.inventory.playermain), "construction-robot", change)
			-- end
			
			-- applyChangeToInventory(game.player.getinventory(defines.inventory.playermain), "construction-robot", newInventoryStore["player"]["construction-robot"] - previousStore["roboport-pocket"]["construction-robot"])
		-- end
		-- if previousStore["roboport-pocket"]["construction-robot"] ~= nil and newInventoryStore["player"]["construction-robot"] == nil then
			-- debugLog("construction-robot: roboPrev" .. previousStore["roboport-pocket"]["construction-robot"])
			
			-- applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(1), "construction-robot", previousStore["roboport-pocket"]["construction-robot"])
			-- --applyChangeToInventory(entityGroup["pocket-provider"].getinventory(1), "construction-robot", previousStore["roboport-pocket"]["construction-robot"])
			-- applyChangeToInventory(game.player.getinventory(defines.inventory.playermain), "construction-robot", previousStore["roboport-pocket"]["construction-robot"])
		-- end
		-- newInventoryStore = createInventoryStore(entityGroup)
	-- end
	
	-- return newInventoryStore
-- end

function syncInventorys(entityGroup, inventoryStore)
	
	local newInventoryStore = createInventoryStore(entityGroup)
	local changes = {}
	
	if newInventoryStore == nil then
		--debugLog("Inventory store is empty, error")
		return
	end
	
	for name, contents in pairs(newInventoryStore) do
		--debugLog("***SYNC: " .. name)
		if inventoryStore[name] == nil then
			changes[name] = getContentsChanges({}, contents)
		else
			changes[name] = getContentsChanges(inventoryStore[name], contents)
		end
	end
	
	applyAllChanges(entityGroup, changes)
end

function applyAllChanges(entityGroup, changes)
	--debugLog("***** Apply all changes")
	for entityName, changeList in pairs(changes) do
		for itemName, diff in pairs(changeList) do
			if itemName == "construction-robot" then 	
				debugLog("Entity: " .. entityName .. " name:" .. itemName .. " diff: " .. diff)
			end
			if entityName ~= "roboport-pocket" and entityGroup["roboport-pocket"] ~= nil and entityGroup["roboport-pocket"].valid then --and (itemName == "repair-pack"  or itemName == "construction-robot")
				
				
				if itemName == "repair-pack" then 
					--if diff > 50 then diff = 50 end
					--if diff < -50 then diff = -50 end
						--debugLog("repair-pack")
					applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(2), itemName, diff)
				elseif itemName == "construction-robot" then
					
					--if diff > 50 then diff = 50 end
					--if diff < -50 then diff = -50 end
					
					applyChangeToInventory(entityGroup["roboport-pocket"].getinventory(1), itemName, diff)
				end
			end
			if entityName ~= "player" then
					--debugLog("Player")
				local overflow = applyChangeToPlayer(game.player, itemName, diff)
				if overflow ~= nil and overflow[itemName] ~= 0 then
					debugLog("Items on ground " .. itemName .. ": " .. overflow[itemName])
					for i=1,overflow[itemName],1 do 
						local position = game.findnoncollidingposition("item-on-ground", game.player.character.position, 100, 0.5)
						game.createentity{name="item-on-ground", position=position, stack={name=itemName, count=1}}  
						
					end
					--game.createentity{name="item-on-ground", position=position, stack={name=itemName, count=overflow[itemName]}}  
					if entityName == "roboport-pocket" and itemName == "repair-pack" then
						applyChangeToInventory(entityGroup[entityName].getinventory(2), itemName, 0-overflow[itemName])
					else
						applyChangeToInventory(entityGroup[entityName].getinventory(1), itemName, 0-overflow[itemName])
					end
				end
			end
			
			if entityName ~= "pocket-provider"  and entityGroup["pocket-provider"] ~= nil and entityGroup["pocket-provider"].valid then --and itemName ~= "repair-pack" and itemName ~= "construction-robot"
					--debugLog("inventory")
				applyChangeToInventory(entityGroup["pocket-provider"].getinventory(1), itemName, diff)
			end
		end
	end
end

function compareContents(contentsA, contentsB)
	for name, count in pairs(contentsA) do
		if contentsB[name] == nil or contentsB[name] ~= count then
			return false
		end
	end
	return true
end

function applyChangeToPlayer(player, name, diff)
	if player ~= nil then
		local inventory = player.getinventory(defines.inventory.playermain)
		if diff > 0 then
			--debugLog(player.name .. " ADD: " .. name .. " - " .. diff)
			if inventory.caninsert({name=name,count=diff}) then
				local previousContents = inventory.getcontents()
				inventory.insert({name=name,count=diff})
				local contents = inventory.getcontents()
				local changes = getContentsChanges(previousContents, contents)
				if changes == nil or changes[name] == nil then
					return {[name]=diff}
				elseif changes[name] ~= nil and changes[name] ~= diff then
					return {[name]=diff - changes[name]}
				end
			else
				return {[name]=diff}
			end
				
		elseif diff < 0 then
			--debugLog(player.name .. " REMOVE: " .. name .. " - " .. diff)
			inventory.remove({name=name,count=0-diff})
		end
	end
	return {[name]=0}
end

function applyChangeToInventory(inventory, name, diff)
	if inventory ~= nil then
		if diff > 0 then
			if name == "construction-robot"  then debugLog("ADD: " .. name .. " - " .. diff) end
			inventory.insert({name=name,count=diff})
		elseif diff < 0 then
			if name == "construction-robot"  then debugLog("REMOVE: " .. name .. " - " .. diff) end
			inventory.remove({name=name,count=0-diff})
		end
	end
end

function getContentsChanges(contentsA, contentsB)
	local changes = {}
	local activeFilter = filter
	if (filter == nil) then
		filter = ""
	end
	
	for name,count in pairs(contentsA) do
		local diff = getItemDifference(name,contentsB[name], contentsA[name])  --CHANGEED
		if diff ~= 0 then
			--debugLog(name .. ": " .. diff)
			changes[name] = diff
		end
		
	end
	
	for name,count in pairs(contentsB) do
		if contentsA[name] == nul then
			changes[name] = getItemDifference(name,contentsB[name],contentsA[name])  --CHANGEED
			--debugLog(name .. " NOT IN A: " .. changes[name])
		end
	end
	
	return changes
end

function getItemDifference(item, countA, countB)
	if countA == nil then
		if countB ~= nil then
			--if countB ~= 0 then debugLog(item .. " B: " ..countB) end
			return 0 - countB
		end
	elseif countB == nil then 
		--if countA ~= 0 then debugLog(item .. " A: " ..countA) end
		return countA
	else
		--local temp = countA - countB
		--if temp ~= 0 then debugLog(item .. ": " .. temp .. " A:" .. countA .. " B:" .. countB) end
		return countA - countB
	end
	
	return 0
end

function matchStringInTable(stringA, tableA)
	for i, stringB in ipairs(tableA) do
		if stringA == stringB then
			return true
		end
	end
	return false
end

function debugLog(message)
	if false then -- set for debug
		game.getplayer().print(message)
	end
end

function endswith(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end